<?php



include_once(dirname(__FILE__) . '/../dashlethelper.inc.php');

//initialization function
myWeather_dashlet_init();

function myWeather_dashlet_init()
{

    $name = "weatherDash";

    $args = array(

        // need a name
        DASHLET_NAME => $name,

        // informative information
        DASHLET_VERSION => "1.0",
        DASHLET_DATE => "06-20-2017",
        DASHLET_AUTHOR => "Nik Polovenko",
        DASHLET_DESCRIPTION => "Check the weather live with this dashlet",
        DASHLET_COPYRIGHT => "Dashlet Copyright &copy; 2017 Nagios Enterprises.",
        DASHLET_LICENSE => "OpenWeatherMap",
        DASHLET_HOMEPAGE => "https://www.nagios.com",

        DASHLET_FUNCTION => "myWeather_dashlet_func",

        DASHLET_TITLE => "Weather Live",

        DASHLET_OUTBOARD_CLASS => "weatherDash_outboardclass",
        DASHLET_INBOARD_CLASS => "weatherDash_inboardclass",
        DASHLET_PREVIEW_CLASS => "weatherDash_previewclass",


        DASHLET_WIDTH => "240",
        DASHLET_HEIGHT => "314",
        DASHLET_OPACITY => "1.0",
        DASHLET_BACKGROUND => "",
    );

    register_dashlet($name, $args);
}



function myWeather_dashlet_func($mode = DASHLET_MODE_PREVIEW, $id = "", $args = null)
{

    $output = "";

    $imgbase = file_get_contents("http://www.freeiconspng.com/uploads/thermometer-png-icon-23.png");

    switch ($mode) {
        case DASHLET_MODE_GETCONFIGHTML:
            $output = '
			<h1>Hello!</h1>
			<BR CLASS="nobr" />
			<LABEL FOR="location">Please choose the city</LABEL>
			<BR CLASS="nobr" />
			<SELECT NAME="location" ID="location">
			' . locations() . '
			</SELECT>
			<BR CLASS="nobr" />
			<BR CLASS="nobr" />
			<BR CLASS="nobr" />
			';
            break;



        case DASHLET_MODE_OUTBOARD:
        case DASHLET_MODE_INBOARD:




        	$city = $args["location"];
        	$url = "http://api.openweathermap.org/data/2.5/weather?q=" . $city . "&APPID=30409188f08229e00b084f6238dec37a";
        	$json=file_get_contents($url);
        	$data=json_decode($json,true);
        	$temp_kelvin = $data['main']['temp'];
        	$temperature = round((($temp_kelvin - 273.15) * 1.8) + 32);
        	date_default_timezone_set('America/Chicago');
        	$date = date('m/d/Y h:i:s a', time());
          $url = $data['weather'][0]['icon'];


        			 $output = "
                     <meta http-equiv=\"refresh\" content=\"3600\" />
        			 <div style=\"width: 240px;height: 302px;\" class=\"container\">
        			 <div class=\"thumbnail\">
        			 <img style=\"display: block;margin: 0 auto;\" src=\"http://openweathermap.org/img/w/$url.png\">
        			 <div class=\"caption .text-center\">
        			 <p><b>Today the temperature in $city is " . $temperature . " degrees F.</p>
               <p>Wind speed is " . $data['wind']['speed'] . " mph.</p>
        			 <p>Humidity is " . $data['main']['humidity'] . "%, " . $data['weather'][0]['description'] . ".</p></b>
        			 <p>Last time checked " . $date . "</p>
        			 </div>
        			  </div>
        			 </div>
        			 ";



            break;
        case DASHLET_MODE_PREVIEW:
            $output = "<p><img style=\"display: block;margin: 0 auto;\" src='https://ibin.co/3QfIHzm8mRn3.png'></p>";
            break;
    }

    return $output;
}



function locations()
{
    $output = '<option value="SaintPaul">Saint Paul; Minnesota</option>
	<option value="NewYork">New York City; New York</option>
<option value="LosAngeles">Los Angeles; California</option>
<option value="Chicago">Chicago; Illinois</option>
<option value="Houston">Houston; Texas</option>
<option value="Philadelphia">Philadelphia; Pennsylvania</option>
<option value="Phoenix">Phoenix; Arizona</option>
<option value="SanAntonio">San Antonio; Texas</option>
<option value="San Diego">San Diego; California</option>
<option value="Dallas">Dallas; Texas</option>
<option value="SanJose">San Jose; California</option>
<option value="Austin">Austin; Texas</option>
<option value="Jacksonville">Jacksonville; Florida</option>
<option value="Indianapolis">Indianapolis; Indiana</option>
<option value="SanFrancisco">San Francisco; California</option>
<option value="Seattle">Seattle; Washington</option>
<option value="Minneapolis">Minneapolis; Minnesota</option>
	';
    return $output;
}
